
package testClientRmi;

import java.rmi.*;
import java.util.*;
import org.ofbiz.entity.GenericDelegator;
import org.ofbiz.service.GenericDispatcher;
import org.ofbiz.service.rmi.*;
import org.ofbiz.base.util.*;
import org.ofbiz.entity.util.*;

/*
    test class to access some services exposed by Ofbiz via rmi
*/
public class Hello3Client {
    
    public static void main(String args[]) {

    String helloPersonId,firstName,lastName,endpoint;
    Map resultCreate, resultQuery;

    // set endpoint where Ofbiz is responding via rmi
    endpoint = "rmi://127.0.0.1:1099/RMIDispatcher";
    
    // set input parameters for the Ofbiz service createHelloPerson
    firstName = "Donald";
    lastName  = "Duck";

        try {
            // look up the remote object by name in the rmi registry
            RemoteDispatcher rd = (RemoteDispatcher) Naming.lookup(endpoint);
            
            System.out.println("");
            
            // create Donald Duck by invoking the Ofbiz service createHelloPerson
            resultCreate = rd.runSync("createHelloPerson",
                                    UtilMisc.toMap("firstName",firstName,"lastName",lastName));
            helloPersonId = (String) resultCreate.get("helloPersonId");
            System.out.println("created person:" + resultCreate);
            System.out.println("");
            
            // search for Donald Duck by invoking the Ofbiz service searchHelloPerson
            // and passing the helloPersonId input parameter retrieved previously
            resultQuery = rd.runSync("searchHelloPerson",
                                    UtilMisc.toMap("helloPersonId",helloPersonId));
            System.out.println("query the previously created person:" + resultQuery);
            System.out.println("");
             
            // search for non existing person by invoking the Ofbiz service searchHelloPerson
            // and passing a helloPersonId not present into the database table hello_person
            resultQuery = rd.runSync("searchHelloPerson",
                                    UtilMisc.toMap("helloPersonId","99999"));
            System.out.println("query a non existing person:" + resultQuery); 
            
        } catch (Exception e) {
            System.err.println("Hello3Client exception: " + 
                               e.getMessage());
            e.printStackTrace();
        }
    }
}