
package testBabelFish;

import java.util.*;
import java.net.*; 
import java.rmi.*; 
import javax.xml.namespace.*; 
import javax.xml.rpc.*; 
import javax.wsdl.OperationType;
import org.apache.axis.encoding.XMLType;
import org.apache.axis.client.Call; 
import org.apache.axis.client.Service; 
import org.apache.axis.utils.*;

/*
    test class to access a web service exposed by Ofbiz
*/ 
public class BabelFishClientSoap { 
    
    public static void main(String[] args) { 
        
        String message = ""; 
        Map output;
        ArrayList outputList;
        String translationmode,sourcedate,result,endpoint;
    
    try { 
        endpoint = "http://services.xmethods.net:80/perl/soaplite.cgi";
        // input parameter to pass
        translationmode = "en_fr";
        sourcedate = "I am";
        
        // create the standard JAX-RPC Call object
        Call call = (Call) new Service().createCall(); 
        // set the endpoint
        call.setTargetEndpointAddress(new URL(endpoint)); 
        // set the WS name and method to invoke
        call.setOperationName(new QName("urn:xmethodsBabelFish", "BabelFish")); 
        
        //define input parameters by name
        call.addParameter("translationmode",
                          org.apache.axis.Constants.XSD_STRING,
                          javax.xml.rpc.ParameterMode.IN);
        call.addParameter("sourcedate",
                          org.apache.axis.Constants.XSD_STRING,
                          javax.xml.rpc.ParameterMode.IN);                          
        call.setReturnType(org.apache.axis.Constants.XSD_STRING);
        
        System.out.println( "Invoking call");
        // the first output parameter is in the response
        Object responseWS = call.invoke(new Object[]{translationmode,sourcedate}); 
        System.out.println( "Receiving response: " +  (String) responseWS); 

        outputList = (ArrayList) call.getOutputValues();
        // the first output parameter is missing
        for (int i=0;i<outputList.size();i++){
            System.out.println("Reading parameter by position: [" + i + "]  = " + outputList.get(i));
        }

    } catch (MalformedURLException ex) { 
        message = "error: wrong url"; 
    } catch (ServiceException ex) { 
        message = "error: failed to create the call"; 
    } catch (RemoteException ex) { 
        message = "error: failed to invoke WS";
        System.out.println("ecc:" + ex);
    } finally { 
      System.out.println(""); 
      System.out.println(message); 
    } 
  } 
}     